{ ****************************************************************** }
{                                                                    }
{   Freeware VCL component TSoftShare 1.1                            }
{                                                                    }
{   Code generated with UltraEdit                                    }
{                                                                    }
{   on 03 Mar 1999 at 13:00                                          }
{                                                                    }
{   Copyright  1998 by David Martinz                                }
{                                                                    }
{                                                                    }
{  History                                                           }
{                                                                    }
{   v1.1 03/99 One new feature added                                 }
{        - Time Limit protection                                     }
{          RunMinutes                                                }
{                                                                    }
{   v1.0 09/98 Initial release                                       }
{                                                                    }
{ ****************************************************************** }

unit Sshare;

interface

uses Windows, Messages, SysUtils, Classes, Controls, Forms,
     Graphics, Registry, ExtCtrls;

type
  TSoftShare = class(TComponent)
    private
      { Private fields of TSoftShare }
        FEncrypKey : String;
        FRegistered : Boolean;
        FRegistryKey : String;
        FSecondRegKey : String;
        FRegName : String;
        FTrialDays : Integer;
        FRemainDays: Double;
        FRunMinutes: Integer;
        FOnBackTime : TNotifyEvent;
        FOnExpired : TNotifyEvent;
        FOnFirstDay : TNotifyEvent;
        FOnInvalidKey : TNotifyEvent;
        FOnRegister : TNotifyEvent;
        FOnRegRead : TNotifyEvent;
        FOnRegWrite : TNotifyEvent;
        FOnEndTime : TNotifyEvent;
        FUseHDSerial : Boolean;
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;
        function GetEncrypKey : String;
        procedure SetEncrypKey(Value : String);
        function GetRegistered : Boolean;
        function GetRegistryKey : String;
        procedure SetRegistryKey(Value : String);
        function GetSecondRegKey : String;
        procedure SetSecondRegKey(Value : String);
        function GetRegName : String;
        procedure SetRegName(Value : String);
        function GetTrialDays : Integer;
        procedure SetTrialDays(Value : Integer);
        function GetRunMinutes : Integer;
        procedure SetRunMinutes(Value : Integer);
    protected
        procedure BackTime;
        procedure Expired;
        procedure FirstDay;
        procedure InvalidKey;
        procedure Register;
        procedure RegRead;
        procedure RegWrite;
        procedure Loaded; override;
        procedure TimerEvent(Sender: TObject);
        procedure EndTime;
    public
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;
        function Execute : Boolean;
        procedure PutRegCode(Name, KeyCode: string);
        function GetKeyString(Name: string): string;
        procedure CheckProtection;
    published
        property OnBackTime : TNotifyEvent read FOnBackTime write FOnBackTime;
        property OnExpired : TNotifyEvent read FOnExpired write FOnExpired;
        property OnFirstDay : TNotifyEvent read FOnFirstDay write FOnFirstDay;
        property OnInvalidKey : TNotifyEvent read FOnInvalidKey write FOnInvalidKey;
        property OnRegister : TNotifyEvent read FOnRegister write FOnRegister;
        property Registered : Boolean read GetRegistered write FRegistered default False;
        property OnRegRead : TNotifyEvent read FOnRegRead write FOnRegRead;
        property OnRegWrite : TNotifyEvent read FOnRegWrite write FOnRegWrite;
        property OnEndTime : TNotifyEvent read FOnEndTime write FOnEndTime;
        property EncrypKey : String read GetEncrypKey write SetEncrypKey;
        property RegistryKey : String read GetRegistryKey write SetRegistryKey;
        property SecondRegKey : String
             read GetSecondRegKey write SetSecondRegKey;
        property RegName : String read GetRegName write SetRegName;
        property TrialDays : Integer
             read GetTrialDays write SetTrialDays
             default 14;
        property RemainDays: Double read FRemainDays;
        property RunMinutes: Integer read GetRunMinutes write SetRunMinutes
             default 0;
        property UseHDSerial: Boolean read FUseHDSerial write FUseHDSerial;

  end;
  function GetHDSerialNumber: LongInt;

procedure Register;

implementation

var
  Timer: TTimer;
  NMin: Integer;

procedure Register;
begin
     RegisterComponents('Samples', [TSoftShare]);
end;

procedure TSoftShare.AutoInitialize;
begin
     FTrialDays := 14;
     FRegName := 'UNREGISTERED';
     FRegistryKey := 'SOFTWARE\SoftShare';
     NMin := 0;
     FUseHDSerial := False;
end; { of AutoInitialize }

procedure TSoftShare.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end;

function TSoftShare.GetEncrypKey : String;
begin
     Result := FEncrypKey
end;

procedure TSoftShare.SetEncrypKey(Value : String);
begin
     FEncrypKey := Value;
end;

function TSoftShare.GetRegistered : Boolean;
begin
     Result := FRegistered
end;

function TSoftShare.GetRegistryKey : String;
begin
     Result := FRegistryKey
end;

procedure TSoftShare.SetRegistryKey(Value : String);
begin
     FRegistryKey := Value;
end;

function TSoftShare.GetSecondRegKey : String;
begin
     Result := FSecondRegKey
end;

procedure TSoftShare.SetSecondRegKey(Value : String);
begin
     FSecondRegKey := Value;
end;

function TSoftShare.GetRegName : String;
begin
     Result := FRegName
end;

procedure TSoftShare.SetRegName(Value : String);
begin
     FRegName := Value;
end;

function TSoftShare.GetTrialDays : Integer;
begin
     Result := FTrialDays
end;

procedure TSoftShare.SetTrialDays(Value : Integer);
begin
     FTrialDays := Value;
end;

function TSoftShare.GetRunMinutes : Integer;
begin
     Result := FRunMinutes;
end;

procedure TSoftShare.SetRunMinutes(Value : Integer);
begin
     FRunMinutes := Value;
end;

procedure TSoftShare.BackTime;
begin
     if Assigned(FOnBackTime) then
        FOnBackTime(Self)
end;

procedure TSoftShare.Expired;
begin
     if Assigned(FOnExpired) then
        FOnExpired(Self)
end;

procedure TSoftShare.FirstDay;
begin
     if Assigned(FOnFirstDay) then
        FOnFirstDay(Self)
end;

procedure TSoftShare.InvalidKey;
begin
     if Assigned(FOnInvalidKey) then
        FOnInvalidKey(Self)
end;

procedure TSoftShare.Register;
begin
     if Assigned(FOnRegister) then
        FOnRegister(Self)
end;

procedure TSoftShare.RegRead;
begin
     if Assigned(FOnRegRead) then
        FOnRegRead(Self)
end;

procedure TSoftShare.RegWrite;
begin
     if Assigned(FOnRegWrite) then
        FOnRegWrite(Self)
end;

procedure TSoftShare.EndTime;
begin
     if Assigned(FOnEndTime) then
        FOnEndTime(Self)
end;

constructor TSoftShare.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     AutoInitialize;
end;

destructor TSoftShare.Destroy;
begin
     AutoDestroy;
     inherited Destroy;
end;

procedure TSoftShare.Loaded;
begin
     inherited Loaded;
end;

procedure TSoftShare.TimerEvent(Sender: TObject);
begin
  Inc(NMin);
  if NMin = FRunMinutes then
    EndTime;
end;

function TSoftShare.Execute : Boolean;
begin
     Result := True
end;

procedure TSoftShare.PutRegCode(Name, KeyCode: string);
var
  Reg: TRegistry;
begin
  if FRegistryKey = '' then exit;
  Reg:=TRegistry.Create;
  Reg.RootKey:=HKEY_LOCAL_MACHINE;
  Reg.OpenKey(FRegistryKey, true);
  Reg.WriteString('Reg-name', Name);
  Reg.WriteString('Reg-key', KeyCode);
  RegWrite;
  Reg.CloseKey;
  Reg.Free;
  CheckProtection;
  if FRegistered then
    Register;
  if FSecondRegKey = '' then exit;
  Reg.OpenKey(FSecondRegKey, true);
  Reg.WriteString('Reg-name', Name);
  Reg.WriteString('Reg-key', KeyCode);
  RegWrite;
  Reg.CloseKey;
  Reg.Free;
  CheckProtection;
  if FRegistered then
    Register;
end;

function TSoftShare.GetKeyString(Name: string): string;
var
  S, Tmp: string;
  I, N, PN: LongInt;
{*******Prime Number Function********}
  function Prime(n: byte): boolean;
  var
    i, ndiv: byte;
  begin
    ndiv:=2;
    Result:=true;
    for i:=2 to n-1 do
    begin
      if (n mod i) = 0 then
        inc(ndiv);
        if ndiv > 2 then
        begin
          result:=false;
          break;
        end
    end;
  end;
{************************************}
begin
  N:=0;
  if FUseHDSerial then
    S:=Name + IntToHex(GetHDSerialNumber, 8) else
    S:=Name;
  for i:=1 to length(S) do
    begin
      if Prime(ord(S[i])) then Tmp:=Tmp + UpperCase(S[i]);
      if i <> 1 then Pn:=ord(S[i-1]) else Pn:=ord(S[1]);
        N:=Pn shl 3 + N;
    end;
  if FUseHDSerial then
  N:=N+GetHDSerialNumber;
  S:=Tmp + IntToStr(N);
  if FUseHDSerial then
  Result:=IntToHex(GetHDSerialNumber, 8) + '-' + S else
  Result:=S;
end;

procedure TSoftShare.CheckProtection;
var
  Rname, Rkey: string;
  IDate, LDate: TDateTime;
  Reg: TRegistry;
begin
  LDate:=Date;
  if FRegistryKey = '' then exit;
  Reg:=TRegistry.Create;
  Reg.RootKey:=HKEY_LOCAL_MACHINE;
  if not Reg.KeyExists(FRegistryKey) then
    begin
      FirstDay;
      Reg.OpenKey(FRegistryKey, true);
      IDate:=Date;
      Reg.WriteDate('Id', IDate);
      Reg.WriteDate('Ld', IDate);
      Reg.WriteString('Reg-name', FRegName);
      Reg.WriteString('Reg-key', '');
      RegWrite;
    end
  else
    begin
      Reg.OpenKey(FRegistryKey, false);
      IDate:=Reg.ReadDate('Id');
      RName:=Reg.ReadString('Reg-name');
      Rkey:=Reg.ReadString('Reg-key');
      LDate:=Reg.ReadDate('Ld');
      RegRead;
      if Rkey <> GetkeyString(RName) then
        begin
          if Rkey <> '' then
          InvalidKey;
          FRemainDays:=FTrialDays - (Date - IDate);
          if (Date - IDate) > FTrialDays then Expired;
          if Date < LDate then BackTime;
        end
      else
        begin
          FRegistered:=True;
          RegName:=RName;
        end;
      LDate:=Date;
      Reg.WriteDate('Ld', LDate);
      RegWrite;
    end;
  Reg.CloseKey;
  Reg.Free;
  if FRunMinutes > 0 then
  begin
    Timer:=TTimer.Create(Self);
    Timer.Interval:=60000;
    Timer.OnTimer:=TimerEvent;
  end;
  if FSecondRegKey = '' then exit;
  Reg:=TRegistry.Create;
  Reg.RootKey:=HKEY_LOCAL_MACHINE;
  if not Reg.KeyExists(FSecondRegKey) then
    begin
      Reg.OpenKey(FSecondRegKey, true);
      IDate:=Date;
      Reg.WriteDate('Id', IDate);
      Reg.WriteDate('Ld', IDate);
      Reg.WriteString('Reg-name', FRegName);
      Reg.WriteString('Reg-key', '');
    end
  else
    begin
      Reg.OpenKey(FSecondRegKey, false);
      IDate:=Reg.ReadDate('Id');
      LDate:=Reg.ReadDate('Ld');
      RName:=Reg.ReadString('Reg-name');
      Rkey:=Reg.ReadString('Reg-key');
      if Rkey <> GetkeyString(RName) then
        begin
          if Rkey <> '' then
          InvalidKey;
          FRemainDays:=FTrialDays - (Date - IDate);
          if (Date - IDate) > FTrialDays then Expired;
          if Date < LDate then BackTime;
        end
      else
        begin
          FRegistered:=True;
          RegName:=RName;
        end;
      LDate:=Date;
      Reg.WriteDate('Ld', LDate);  
    end;
  Reg.CloseKey;
  Reg.Free;
end;

function GetHDSerialNumber: LongInt;
{$IFDEF WIN32}
var
  pdw : pDWord;
  mc, fl : dword;
{$ENDIF}
begin
  {$IfDef WIN32}
  New(pdw);
  GetVolumeInformation(nil,nil,0,pdw,mc,fl,nil,0);
  Result := pdw^;
  dispose(pdw);
  {$ELSE}
  Result := GetWinFlags;
  {$ENDIF}
end;

end.
